//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "TcpProxy")]
pub struct Model {
    #[sea_orm(primary_key, auto_increment = false, column_type = "Text")]
    pub domain: String,
    #[sea_orm(column_name = "ownerName", column_type = "Text")]
    pub owner_name: String,
    #[sea_orm(column_name = "serviceId")]
    pub service_id: Uuid,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(
        belongs_to = "super::service::Entity",
        from = "Column::ServiceId",
        to = "super::service::Column::Id",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    Service,
    #[sea_orm(
        belongs_to = "super::user::Entity",
        from = "Column::OwnerName",
        to = "super::user::Column::Username",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    User,
}

impl Related<super::service::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Service.def()
    }
}

impl Related<super::user::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::User.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
